Index: hw/gumstix.c
===================================================================
--- hw/gumstix.c	(revision 4734)
+++ hw/gumstix.c	(working copy)
@@ -77,8 +77,8 @@
     cpu->env->regs[15] = 0x00000000;
 
     /* Interrupt line of NIC is connected to GPIO line 36 */
-    smc91c111_init(&nd_table[0], 0x04000300,
-                    pxa2xx_gpio_in_get(cpu->gpio)[36]);
+    qemu_register_irqs("pic0", pxa2xx_gpio_in_get(cpu->gpio) + 36, 1);
+    smc91c111_set_defaults(0x04000300, pxa2xx_gpio_in_get(cpu->gpio) + 36, 0);
 }
 
 static void verdex_init(ram_addr_t ram_size, int vga_ram_size,
@@ -117,8 +117,8 @@
     cpu->env->regs[15] = 0x00000000;
 
     /* Interrupt line of NIC is connected to GPIO line 99 */
-    smc91c111_init(&nd_table[0], 0x04000300,
-                    pxa2xx_gpio_in_get(cpu->gpio)[99]);
+    qemu_register_irqs("pic0", pxa2xx_gpio_in_get(cpu->gpio) + 99, 1);
+    smc91c111_set_defaults(0x04000300, pxa2xx_gpio_in_get(cpu->gpio) + 99, 0);
 }
 
 QEMUMachine connex_machine = {
@@ -126,6 +126,7 @@
     "Gumstix Connex (PXA255)",
     connex_init,
     (0x05000000 + PXA2XX_INTERNAL_SIZE) | RAMSIZE_FIXED,
+    "smc91c111",
 };
 
 QEMUMachine verdex_machine = {
@@ -133,4 +134,5 @@
     "Gumstix Verdex (PXA270)",
     verdex_init,
     (0x12000000 + PXA2XX_INTERNAL_SIZE) | RAMSIZE_FIXED,
+    "smc91c111",
 };
Index: hw/mips_malta.c
===================================================================
--- hw/mips_malta.c	(revision 4734)
+++ hw/mips_malta.c	(working copy)
@@ -458,51 +458,6 @@
     return s;
 }
 
-/* Audio support */
-#ifdef HAS_AUDIO
-static void audio_init (PCIBus *pci_bus)
-{
-    struct soundhw *c;
-    int audio_enabled = 0;
-
-    for (c = soundhw; !audio_enabled && c->name; ++c) {
-        audio_enabled = c->enabled;
-    }
-
-    if (audio_enabled) {
-        AudioState *s;
-
-        s = AUD_init ();
-        if (s) {
-            for (c = soundhw; c->name; ++c) {
-                if (c->enabled)
-                    c->init.init_pci (pci_bus, s);
-            }
-        }
-    }
-}
-#endif
-
-/* Network support */
-static void network_init (PCIBus *pci_bus)
-{
-    int i;
-    NICInfo *nd;
-
-    for(i = 0; i < nb_nics; i++) {
-        nd = &nd_table[i];
-        if (!nd->model) {
-            nd->model = "pcnet";
-        }
-        if (i == 0  && strcmp(nd->model, "pcnet") == 0) {
-            /* The malta board has a PCNet card using PCI SLOT 11 */
-            pci_nic_init(pci_bus, nd, 88);
-        } else {
-            pci_nic_init(pci_bus, nd, -1);
-        }
-    }
-}
-
 /* ROM and pseudo bootloader
 
    The following code implements a very very simple bootloader. It first
@@ -933,17 +888,26 @@
     }
     floppy_controller = fdctrl_init(i8259[6], 2, 0, 0x3f0, fd);
 
-    /* Sound card */
-#ifdef HAS_AUDIO
-    audio_init(pci_bus);
-#endif
-
-    /* Network card */
-    network_init(pci_bus);
-
     /* Optional PCI video card */
     pci_cirrus_vga_init(pci_bus, ds, phys_ram_base + ram_size,
                         ram_size, vga_ram_size);
+
+    /* set default pcnet devfn number */
+    {
+        QEMUDevice *dev;
+        QEMUDeviceClass *dc;
+        
+        dc = qemu_class_find("pcnet");
+        for(dev = qemu_first_device; dev != NULL; dev = dev->dev_next) {
+            if (dev->dev_class == dc) {
+                if (qemu_device_get_int(dev, "devfn") == -1) {
+                    qemu_device_set_int(dev, "devfn", 88);
+                }
+                break;
+            }
+        }
+    }
+    qemu_register_irqs("isapic0", i8259, 16);
 }
 
 QEMUMachine mips_malta_machine = {
@@ -951,4 +915,5 @@
     "MIPS Malta Core LV",
     mips_malta_init,
     VGA_RAM_SIZE + BIOS_SIZE,
+    "pcnet",
 };
Index: hw/devices.h
===================================================================
--- hw/devices.h	(revision 4734)
+++ hw/devices.h	(working copy)
@@ -5,6 +5,7 @@
 
 /* smc91c111.c */
 void smc91c111_init(NICInfo *, uint32_t, qemu_irq);
+void smc91c111_set_defaults(uint32_t membase, qemu_irq *pic, int irq_num);
 
 /* ssd0323.c */
 int ssd0323_xfer_ssi(void *opaque, int data);
Index: hw/pc.c
===================================================================
--- hw/pc.c	(revision 4734)
+++ hw/pc.c	(working copy)
@@ -659,59 +659,12 @@
 static const int ide_iobase2[2] = { 0x3f6, 0x376 };
 static const int ide_irq[2] = { 14, 15 };
 
-#define NE2000_NB_MAX 6
-
-static int ne2000_io[NE2000_NB_MAX] = { 0x300, 0x320, 0x340, 0x360, 0x280, 0x380 };
-static int ne2000_irq[NE2000_NB_MAX] = { 9, 10, 11, 3, 4, 5 };
-
 static int serial_io[MAX_SERIAL_PORTS] = { 0x3f8, 0x2f8, 0x3e8, 0x2e8 };
 static int serial_irq[MAX_SERIAL_PORTS] = { 4, 3, 4, 3 };
 
 static int parallel_io[MAX_PARALLEL_PORTS] = { 0x378, 0x278, 0x3bc };
 static int parallel_irq[MAX_PARALLEL_PORTS] = { 7, 7, 7 };
 
-#ifdef HAS_AUDIO
-static void audio_init (PCIBus *pci_bus, qemu_irq *pic)
-{
-    struct soundhw *c;
-    int audio_enabled = 0;
-
-    for (c = soundhw; !audio_enabled && c->name; ++c) {
-        audio_enabled = c->enabled;
-    }
-
-    if (audio_enabled) {
-        AudioState *s;
-
-        s = AUD_init ();
-        if (s) {
-            for (c = soundhw; c->name; ++c) {
-                if (c->enabled) {
-                    if (c->isa) {
-                        c->init.init_isa (s, pic);
-                    }
-                    else {
-                        if (pci_bus) {
-                            c->init.init_pci (pci_bus, s);
-                        }
-                    }
-                }
-            }
-        }
-    }
-}
-#endif
-
-static void pc_init_ne2k_isa(NICInfo *nd, qemu_irq *pic)
-{
-    static int nb_ne2k = 0;
-
-    if (nb_ne2k == NE2000_NB_MAX)
-        return;
-    isa_ne2000_init(ne2000_io[nb_ne2k], pic[ne2000_irq[nb_ne2k]], nd);
-    nb_ne2k++;
-}
-
 /* PC hardware initialisation */
 static void pc_init1(ram_addr_t ram_size, int vga_ram_size,
                      const char *boot_device, DisplayState *ds,
@@ -727,7 +680,6 @@
     PCIBus *pci_bus;
     int piix3_devfn = -1;
     CPUState *env;
-    NICInfo *nd;
     qemu_irq *cpu_irq;
     qemu_irq *i8259;
     int index;
@@ -943,30 +895,6 @@
         }
     }
 
-    for(i = 0; i < nb_nics; i++) {
-        nd = &nd_table[i];
-        if (!nd->model) {
-            if (pci_enabled) {
-                nd->model = "ne2k_pci";
-            } else {
-                nd->model = "ne2k_isa";
-            }
-        }
-        if (strcmp(nd->model, "ne2k_isa") == 0) {
-            pc_init_ne2k_isa(nd, i8259);
-        } else if (pci_enabled) {
-            if (strcmp(nd->model, "?") == 0)
-                fprintf(stderr, "qemu: Supported ISA NICs: ne2k_isa\n");
-            pci_nic_init(pci_bus, nd, -1);
-        } else if (strcmp(nd->model, "?") == 0) {
-            fprintf(stderr, "qemu: Supported ISA NICs: ne2k_isa\n");
-            exit(1);
-        } else {
-            fprintf(stderr, "qemu: Unsupported NIC: %s\n", nd->model);
-            exit(1);
-        }
-    }
-
     if (drive_get_max_bus(IF_IDE) >= MAX_IDE_BUS) {
         fprintf(stderr, "qemu: too many IDE bus\n");
         exit(1);
@@ -991,9 +919,6 @@
 
     i8042_init(i8259[1], i8259[12], 0x60);
     DMA_init(0);
-#ifdef HAS_AUDIO
-    audio_init(pci_enabled ? pci_bus : NULL, i8259);
-#endif
 
     for(i = 0; i < MAX_FD; i++) {
         index = drive_get_index(IF_FLOPPY, 0, i);
@@ -1042,6 +967,7 @@
 	    }
         }
     }
+    qemu_register_irqs("isapic0", i8259, 16);
 }
 
 static void pc_init_pci(ram_addr_t ram_size, int vga_ram_size,
@@ -1073,6 +999,7 @@
     "Standard PC",
     pc_init_pci,
     VGA_RAM_SIZE + PC_MAX_BIOS_SIZE,
+    "ne2k_pci",
 };
 
 QEMUMachine isapc_machine = {
@@ -1080,4 +1007,5 @@
     "ISA-only PC",
     pc_init_isa,
     VGA_RAM_SIZE + PC_MAX_BIOS_SIZE,
+    "ne2k_isa",
 };
Index: hw/pci.c
===================================================================
--- hw/pci.c	(revision 4734)
+++ hw/pci.c	(working copy)
@@ -112,6 +112,15 @@
     return bus;
 }
 
+/* XXX: add naming info. The empty string is the "default" PCI bus. */
+PCIBus *pci_bus_from_name(const char *bus_name)
+{
+    if (bus_name[0] == '\0')
+        return first_bus;
+    else
+        return NULL;
+}
+
 int pci_bus_num(PCIBus *s)
 {
     return s->bus_num;
@@ -623,33 +632,6 @@
     pci_for_each_device(0, pci_info_device);
 }
 
-/* Initialize a PCI NIC.  */
-void pci_nic_init(PCIBus *bus, NICInfo *nd, int devfn)
-{
-    if (strcmp(nd->model, "ne2k_pci") == 0) {
-        pci_ne2000_init(bus, nd, devfn);
-    } else if (strcmp(nd->model, "i82551") == 0) {
-        pci_i82551_init(bus, nd, devfn);
-    } else if (strcmp(nd->model, "i82557b") == 0) {
-        pci_i82557b_init(bus, nd, devfn);
-    } else if (strcmp(nd->model, "i82559er") == 0) {
-        pci_i82559er_init(bus, nd, devfn);
-    } else if (strcmp(nd->model, "rtl8139") == 0) {
-        pci_rtl8139_init(bus, nd, devfn);
-    } else if (strcmp(nd->model, "e1000") == 0) {
-        pci_e1000_init(bus, nd, devfn);
-    } else if (strcmp(nd->model, "pcnet") == 0) {
-        pci_pcnet_init(bus, nd, devfn);
-    } else if (strcmp(nd->model, "?") == 0) {
-        fprintf(stderr, "qemu: Supported PCI NICs: i82551 i82557b i82559er"
-                        " ne2k_pci pcnet rtl8139 e1000\n");
-        exit (1);
-    } else {
-        fprintf(stderr, "qemu: Unsupported NIC: %s\n", nd->model);
-        exit (1);
-    }
-}
-
 typedef struct {
     PCIDevice dev;
     PCIBus *bus;
@@ -697,3 +679,4 @@
     s->bus = pci_register_secondary_bus(&s->dev, map_irq);
     return s->bus;
 }
+
Index: hw/etraxfs.c
===================================================================
--- hw/etraxfs.c	(revision 4734)
+++ hw/etraxfs.c	(working copy)
@@ -105,18 +105,42 @@
     }
 
     /* Add the two ethernet blocks.  */
-    eth[0] = etraxfs_eth_init(&nd_table[0], env, pic->irq + 25, 0xb0034000);
-    if (nb_nics > 1)
-        eth[1] = etraxfs_eth_init(&nd_table[1], env, pic->irq + 26, 0xb0036000);
+    {
+        QEMUDevice *dev;
+        QEMUDeviceClass *dc;
+        int eth_index;
+        NICInfo nd;
 
-    /* The DMA Connector block is missing, hardwire things for now.  */
-    etraxfs_dmac_connect_client(etraxfs_dmac, 0, eth[0]);
-    etraxfs_dmac_connect_client(etraxfs_dmac, 1, eth[0] + 1);
-    if (eth[1]) {
-        etraxfs_dmac_connect_client(etraxfs_dmac, 6, eth[1]);
-        etraxfs_dmac_connect_client(etraxfs_dmac, 7, eth[1] + 1);
+        dc = qemu_class_find("etraxfs_eth");
+        eth_index = 0;
+        for(dev = qemu_first_device; dev != NULL; dev = dev->dev_next) {
+            if (dev->dev_class == dc) {
+                dev->instantiated = 1;
+                if (nd_init(dev, &nd) < 0)
+                    continue;
+                if (eth_index == 0) {
+                    eth[0] = etraxfs_eth_init(&nd, env, 
+                                              pic->irq + 25, 0xb0034000);
+                    /* The DMA Connector block is missing, hardwire
+                       things for now.  */
+                    etraxfs_dmac_connect_client(etraxfs_dmac, 0, eth[0]);
+                    etraxfs_dmac_connect_client(etraxfs_dmac, 1, eth[0] + 1);
+                } else {
+                    eth[1] = etraxfs_eth_init(&nd, 
+                                              env, pic->irq + 26, 0xb0036000);
+                    /* The DMA Connector block is missing, hardwire
+                       things for now.  */
+                    etraxfs_dmac_connect_client(etraxfs_dmac, 6, eth[1]);
+                    etraxfs_dmac_connect_client(etraxfs_dmac, 7, eth[1] + 1);
+                }
+
+                if (++eth_index >= 2)
+                    break;
+            }
+        }
     }
 
+
     /* 2 timers.  */
     etraxfs_timer_init(env, pic->irq + 0x1b, pic->nmi + 1, 0xb001e000);
     etraxfs_timer_init(env, pic->irq + 0x1b, pic->nmi + 1, 0xb005e000);
@@ -155,4 +179,5 @@
     "Bare ETRAX FS board",
     bareetraxfs_init,
     0x8000000,
+    "etraxfs_eth",
 };
Index: hw/musicpal.c
===================================================================
--- hw/musicpal.c	(revision 4734)
+++ hw/musicpal.c	(working copy)
@@ -716,7 +716,7 @@
     mv88w8618_eth_write
 };
 
-static void mv88w8618_eth_init(NICInfo *nd, uint32_t base, qemu_irq irq)
+void mv88w8618_eth_init(NICInfo *nd, uint32_t base, qemu_irq irq)
 {
     mv88w8618_eth_state *s;
     int iomemtype;
@@ -1504,7 +1504,8 @@
 
     qemu_add_kbd_event_handler(musicpal_key_event, pic[MP_GPIO_IRQ]);
 
-    mv88w8618_eth_init(&nd_table[0], MP_ETH_BASE, pic[MP_ETH_IRQ]);
+    qemu_register_irqs("pic0", pic, 32);
+    mv88w8618_eth_set_defaults(MP_ETH_BASE, pic, MP_ETH_IRQ);
 
     mixer_i2c = musicpal_audio_init(MP_AUDIO_BASE, pic[MP_AUDIO_IRQ]);
 
@@ -1519,5 +1520,6 @@
     "musicpal",
     "Marvell 88w8618 / MusicPal (ARM926EJ-S)",
     musicpal_init,
-    MP_RAM_DEFAULT_SIZE + MP_SRAM_SIZE + MP_FLASH_SIZE_MAX + RAMSIZE_FIXED
+    MP_RAM_DEFAULT_SIZE + MP_SRAM_SIZE + MP_FLASH_SIZE_MAX + RAMSIZE_FIXED,
+    "mv88w8618_eth",
 };
Index: hw/pci.h
===================================================================
--- hw/pci.h	(revision 4734)
+++ hw/pci.h	(working copy)
@@ -85,8 +85,8 @@
 typedef int (*pci_map_irq_fn)(PCIDevice *pci_dev, int irq_num);
 PCIBus *pci_register_bus(pci_set_irq_fn set_irq, pci_map_irq_fn map_irq,
                          qemu_irq *pic, int devfn_min, int nirq);
+PCIBus *pci_bus_from_name(const char *bus_name);
 
-void pci_nic_init(PCIBus *bus, NICInfo *nd, int devfn);
 void pci_data_write(void *opaque, uint32_t addr, uint32_t val, int len);
 uint32_t pci_data_read(void *opaque, uint32_t addr, int len);
 int pci_bus_num(PCIBus *s);
Index: hw/hw.h
===================================================================
--- hw/hw.h	(revision 4734)
+++ hw/hw.h	(working copy)
@@ -4,6 +4,7 @@
 
 #include "qemu-common.h"
 #include "irq.h"
+#include "device.h"
 
 /* VM Load/Save */
 
@@ -16,6 +17,8 @@
 void qemu_put_be32(QEMUFile *f, unsigned int v);
 void qemu_put_be64(QEMUFile *f, uint64_t v);
 int qemu_get_buffer(QEMUFile *f, uint8_t *buf, int size);
+int qemu_getc(QEMUFile *f);
+int qemu_get_line(QEMUFile *f, char *buf, int buf_size);
 int qemu_get_byte(QEMUFile *f);
 unsigned int qemu_get_be16(QEMUFile *f);
 unsigned int qemu_get_be32(QEMUFile *f);
Index: hw/mips_r4k.c
===================================================================
--- hw/mips_r4k.c	(revision 4734)
+++ hw/mips_r4k.c	(working copy)
@@ -249,19 +249,6 @@
     isa_vga_init(ds, phys_ram_base + ram_size, ram_size,
                  vga_ram_size);
 
-    if (nd_table[0].vlan) {
-        if (nd_table[0].model == NULL
-            || strcmp(nd_table[0].model, "ne2k_isa") == 0) {
-            isa_ne2000_init(0x300, i8259[9], &nd_table[0]);
-        } else if (strcmp(nd_table[0].model, "?") == 0) {
-            fprintf(stderr, "qemu: Supported NICs: ne2k_isa\n");
-            exit (1);
-        } else {
-            fprintf(stderr, "qemu: Unsupported NIC: %s\n", nd_table[0].model);
-            exit (1);
-        }
-    }
-
     if (drive_get_max_bus(IF_IDE) >= MAX_IDE_BUS) {
         fprintf(stderr, "qemu: too many IDE bus\n");
         exit(1);
@@ -281,6 +268,7 @@
 		     hd[MAX_IDE_DEVS * i + 1]);
 
     i8042_init(i8259[1], i8259[12], 0x60);
+    qemu_register_irqs("isapic0", i8259, 16);
 }
 
 QEMUMachine mips_machine = {
@@ -288,4 +276,5 @@
     "mips r4k platform",
     mips_r4k_init,
     VGA_RAM_SIZE + BIOS_SIZE,
+    "ne2k_isa",
 };
